[codeforces696B]Puzzles

B. Puzzles
time limit per test 
1 second
memory limit per test 256 megabytes
input standard input
output standard output

Barney lives in country USC (United States of Charzeh). USC has n cities numbered from 1 through n and n - 1 roads between them. Cities and roads of USC form a rooted tree (Barney's not sure why it is rooted). Root of the tree is the city number 1. Thus if one will start his journey from city 1, he can visit any city he wants by following roads.

Some girl has stolen Barney's heart, and Barney wants to find her. He starts looking for in the root of the tree and (since he is Barney Stinson not a random guy), he uses a random DFS to search in the cities. A pseudo code of this algorithm is as follows:


let starting_time be an array of length n
current_time = 0
dfs(v):
current_time = current_time + 1
starting_time[v] = current_time
shuffle children[v] randomly (each permutation with equal possibility)
// children[v] is vector of children cities of city v
for u in children[v]:
dfs(u)

As told before, Barney will start his journey in the root of the tree (equivalent to call dfs(1)).

Now Barney needs to pack a backpack and so he wants to know more about his upcoming journey: for every city i, Barney wants to know the expected value of starting_time[i]. He's a friend of Jon Snow and knows nothing, that's why he asked for your help.

Input

The first line of input contains a single integer n (1 ≤ n ≤ 105) — the number of cities in USC.

The second line contains n - 1 integers p2, p3, ..., pn (1 ≤ pi < i), where pi is the number of the parent city of city number i in the tree, meaning there is a road between cities numbered pi and i in USC.

Output

In the first and only line of output print n numbers, where i-th number is the expected value of starting_time[i].

Your answer for each city will be considered correct if its absolute or relative error does not exceed 10 - 6.

Examples
input
7
1 2 1 1 4 4
output
1.0 4.0 5.0 3.5 4.5 5.0 5.0 
input
12
1 1 2 2 4 4 3 3 1 10 8
output
1.0 5.0 5.5 6.5 7.5 8.0 8.0 7.0 7.5 6.5 7.5 8.0 

题解:这道题还相对比较简单……
题意大概就是求每个点的期望dfs序,显然f[1]=1是递推边界
我们考虑对于某一个节点i,设dfs序为f[i],子树大小为size[i],那么f[i]=f[father]+兄弟的贡献+1
而兄弟产生贡献的话,就取决于dfs的先后顺序,如果先dfs兄弟,会产生size[兄弟]的贡献
那么的兄弟的总贡献就是兄弟的子树大小之和/2,即(size[father]-1-size[rt])/2
那么本题就得到了解决,代码见下:
 1 #include <cstdio>
 2 #include <cstring>
 3 using namespace std;
 4 const int N=100100;
 5 int n,fa[N],size[N],e,adj[N];
 6 struct node{int zhong,next;}s[N];
 7 double f[N];
 8 inline void add(int qi,int zhong)
 9     {s[++e].zhong=zhong;s[e].next=adj[qi];adj[qi]=e;}
10 void dfs1(int rt)
11 {
12     size[rt]=1;
13     for(int i=adj[rt];i;i=s[i].next)
14         dfs1(s[i].zhong),size[rt]+=size[s[i].zhong];
15 }
16 void dfs2(int rt)
17 {
18     for(int i=adj[rt];i;i=s[i].next)
19         {int u=s[i].zhong;f[u]=f[rt]+(size[rt]-1-size[u])/2.0+1;dfs2(u);}
20 }
21 int main()
22 {
23     scanf("%d",&n);
24     for(int i=2;i<=n;i++)
25         scanf("%d",&fa[i]),add(fa[i],i);
26     dfs1(1);f[1]=1;dfs2(1);
27     for(int i=1;i<=n;i++)
28         printf("%.8lf ",f[i]);
29 }

 

posted @ 2017-07-28 07:09  LadyLex  阅读(237)  评论(0编辑  收藏  举报